#ifndef FILESYSTEM_H
#define FILESYSTEM__H

#include "hipp.h"

#define 	FS_POLICY_PATH		"/etc/umip/fs_policy.conf"

#define		FS_UNPROTECTED		0
#define		FS_PROTECTED		1
#define		FS_TRUSTED		2
#define		FS_SPECIAL		3
#define		FS_NO_MOUNT_POINT	4

struct fs_prot_struct {
	char* dev_name;
	char* mount_point;
	unsigned char prot_level;
	struct list_head list;
};

int get_fs_prot_level(char* dev_name);
int read_fs_prot_policy(void);
int is_special_fs_type(char* type);
int check_special_fs_type(char* type, char* path);

extern struct namespace* init_namespace;
extern struct fs_prot_struct* fs_prot_list;

#endif
