#ifndef HIPP_H
#define HIPP_H

#include "global.h"

#define		GLOBAL_POLICY_FILE_PATH		"/etc/umip/global_policy.conf"
#define		USER_POLICY_FILE_NAME		"umip/user_policy.conf"
#define		UPGRADE_INTEGRITY_UTILITY_NAME	"/etc/umip/upgrade"

#define		LOCAL_IP		0x7F000001
#define		MAX_PATH_LEN		256
#define		DEFAULT_CAPABILITY	8*8+8*16

/* integrity level */
#define		LOW_INTEGRITY		0
#define		MID_INTEGRITY		1
#define		HIGH_INTEGRITY		2
#define		NO_INTEGRITY		3

/* file exception mode */
#define		CAN_READ			1
#define		CAN_RECURSIVE_READ		2
#define		CAN_WRITE			3
#define		CAN_RECURSIVE_WRITE		4

/* file exception effect */
#define		DROP		0
#define		STAY		1

/* file exception */
struct file_exception_struct {
	char* path;
	int mode;
	int effect;
	struct list_head list;
};

/* exec exception */
struct exec_exception_struct {
	char* path;
	struct list_head list;
};

/* program exception */
struct exception_struct {
	char* path;
	unsigned char fpp;
	unsigned char rap;
	unsigned char lsp;
	struct exec_exception_struct exec_exception;	
	struct exec_exception_struct execinh_exception;	
	struct file_exception_struct file_exception;
	unsigned int cap;
	int user_id;
	struct list_head list;
};

/* user / group types */
#define		NON_ADMIN	0
#define		HALF_ADMIN	1
#define		FULL_ADMIN	2

#define		FULL_ADM_GROUP_NAME	"hipp_full_adm"
#define		HALF_ADM_GROUP_NAME	"hipp_half_adm"

/* normal user accounts */
struct account_list_struct {
	char* account_name;
	int account_number;
	int group_number;
	int user_type;
	char* home_directory;
	struct exception_struct* user_exception;
	struct list_head list;
};

#define		UN_PROTECTED		4

#define		LOW_READ_PROTECTED	1
#define		MID_READ_PROTECTED	2
#define		HIGH_READ_PROTECTED	3

#define		LOW_WRITE_PROTECTED	1
#define		MID_WRITE_PROTECTED	2
#define		HIGH_WRITE_PROTECTED	3

#define		DO_READ		1
#define		DO_WRITE	2
#define		DO_EXEC		4

#define		DIR_RECV	1
#define		DIR_SEND	2

extern struct exception_struct* global_exception;
extern struct account_list_struct* account_list;
extern unsigned int bit_power[32];
extern int HIPP_MAGIC;
extern unsigned int dev_ino;
extern unsigned int tty_ino;

extern int error_code;
#endif
