#include <sys/socket.h>
#include <linux/types.h> 
#include <linux/netlink.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define NETLINK_MASK	32323232
#define NETLINK_UMIP 	22
#define MAX_PAYLOAD 	1024

struct sockaddr_nl src_addr, dest_addr;
struct nlmsghdr *nlh = NULL;
struct msghdr msg;
struct iovec iov;
int sock_fd;
int v, opt = 0;
char p[10];

void print_usage() 
{
	printf("Usages:  umip_mamager OPTION PID\n");
	printf("\t\t OPTION: -e, -p, -d \n");
}

int parse(int argc, char** argv)
{
	if (argc != 3) {
		print_usage();
		return -1;
	}
	
	v = atoi(argv[2]);
	if (strcmp(argv[1], "-e") == 0) {
		opt = 1;
	}
	else if (strcmp(argv[1], "-p") == 0) {
		opt = 2;
	} 
	else if (strcmp(argv[1], "-d") == 0) {
		opt = 3;
	}
	else {
		return -1;
	}
	return 0;
}

int main(int argc, char** argv) 
{
	if (parse(argc, argv) == -1) {
		return 0;
	}	
	
	sock_fd = socket(PF_NETLINK, SOCK_RAW, NETLINK_UMIP);
	
	memset(&src_addr, 0, sizeof(src_addr));
	src_addr.nl_family = AF_NETLINK;      
	src_addr.nl_pid = getpid();
	src_addr.nl_groups = 0;
	
	bind(sock_fd, (struct sockaddr*)&src_addr, sizeof(src_addr));
 	
 	memset(&dest_addr, 0, sizeof(dest_addr));
 	dest_addr.nl_family = AF_NETLINK;
	dest_addr.nl_pid = 0;
	dest_addr.nl_groups = 0;
	
	nlh=(struct nlmsghdr *)malloc(NLMSG_SPACE(MAX_PAYLOAD));
	nlh->nlmsg_len = NLMSG_SPACE(MAX_PAYLOAD);
	nlh->nlmsg_pid = getpid();
	nlh->nlmsg_flags = 0;
	
	iov.iov_base = (void *)nlh;
	iov.iov_len = nlh->nlmsg_len;
	msg.msg_name = (void *)&dest_addr;
	msg.msg_namelen = sizeof(dest_addr);
	msg.msg_iov = &iov;
	msg.msg_iovlen = 1;

	memcpy(p, &opt, sizeof(int));
	memcpy(p + 4, &v, sizeof(int));
	
	memcpy(NLMSG_DATA(nlh), p, 8);
	sendmsg(sock_fd, &msg, 0);
	
	recvmsg(sock_fd, &msg, 0);
	printf(" Response: %s\n", NLMSG_DATA(nlh));
		
	close(sock_fd);
	return 0;
}
