#ifndef UTILITIES_H
#define UTILITIES__H

#include "hipp.h"

//extern struct sock *tcp_v4_lookup(u32 saddr, u16 sport, u32 daddr, u16 dport, int dif);
//extern struct sock *tcp_v6_lookup(struct in6_addr *saddr, u16 sport, struct in6_addr *daddr, u16 dport, int dif);

void get_fs_type_by_inode(struct inode* inode, char* type);
int is_fs_type(struct inode* inode, const char* name);
int get_path_from_dentry(struct dentry* dentry, char* path);
struct dentry* get_dentry_from_path(const char* path);
int is_sticky_set(struct inode* inode);
int is_world_readable(struct inode* inode);
int is_world_writable(struct inode* inode);
int process_sock(struct socket* sock, int dir, struct inode** local_inode, struct sock** loopback_sock);
int set_sticky_bit(struct inode* inode);
struct sock* process_loopback(struct inet_sock* inet, int version);
struct vfsmount* get_vfsmount_by_sb(struct super_block* sb, struct namespace* ns);
int get_absolute_path_by_nd(struct nameidata* nd, char* path);

#endif
